 Unset Automatic Introduction.    (* coq 8.3_rc1 *)
Require Export LIFO.Vector.Vector.
Require Import Bool.
Require Import Arith.
Require Import AlgebraClasses.

Lemma fold_fold:
  forall (A B : Type) (n n' : nat) (v : vector B n)(v' : vector B n')  (op :  A -> B -> A) acc,
  fold_left op v (fold_left op v' acc) = fold_left op (v'++v) acc.
Proof.
  intros A B n n' v v' op .
  induction v'. simpl. reflexivity.
  simpl.  intros acc. apply IHv'.
Qed.


(* Lemma fold_right_const A B f (b:B) l   : (forall a:A , In a l -> f a b = b) -> fold_right f b l = b .  *)
(*   intros. *)
(*   induction l. *)
(*   reflexivity. *)
(*   simpl. *)
(*   rewrite IHl. *)
(*   apply H. *)
(*   simpl. left. reflexivity. *)
(*   intros a0 H0. *)
(*   apply H. simpl. right ;assumption. *)
(* Qed. *)


(* Open Scope bool_scope.  *)
(* Set Implicit Arguments. *)

(* Section fold_left. *)
  
(*   Variable A B : Type. *)
(*   Variable f : A -> B -> A. *)

(*   Lemma fold_left_compose_right_map :  *)
(*     forall (C : Type) (g : C -> B) (l : list C) (a : A), *)
(*       fold_left (fun a b => f a (g b)) l a = fold_left f (map g l) a. *)
(*   Proof. *)
(*     induction l as [ | a l IHl]; intro. *)
(*     reflexivity. *)
(*     simpl; rewrite IHl; reflexivity. *)
(*   Qed. *)

(*   (* Need this one because... something about functional non-extensionality *)  *)
(*   (* ALLREADY DEFINED IN STDLIB : fold_left_f_inv *) *)
(*   Lemma fold_left_compose_right_map' :  *)
(*     forall (C : Type) (g : C -> B) (l : list C) (a : A), *)
(*       fold_left (fun a b => f a (g b)) l a = fold_left (fun a b => f a b) (map g l) a. *)
(*   Proof. *)
(*     induction l as [ | a l IHl]; intro. *)
(*     reflexivity. *)
(*     simpl; rewrite IHl; reflexivity. *)
(*   Qed. *)

(* (* *)
(* Extensionality on fold_left *)
(* *) *)
(* Lemma fold_left_ext : forall (A B : Type) (f g : A -> B -> A) (l : list B) (l1 : A), *)
(*   (forall a i, f a i = g a i) -> fold_left f l l1 = fold_left g l l1. *)
(* Proof. *)
(* induction l ; simpl ; intros. *)
(*  reflexivity. *)
(*  rewrite IHl. rewrite H. reflexivity. *)
(*  apply H. *)
(* Qed. *)

(* End fold_left. *)


(* Section fold_right. *)

(*   Variable A B : Type. *)
(*   Variable f : A -> B -> B. *)

(*   Lemma fold_right_compose_left_map : *)
(*     forall (C : Type) (g : C -> A) (l:list C) (a : B), *)
(*       fold_right (fun a b => f (g a) b) a l = fold_right f a (map g l). *)
(*   Proof. *)
(*     induction l as [ | a l IHl]; intros. *)
(*     reflexivity. *)
(*     simpl. *)
(*     f_equal; rewrite IHl; reflexivity. *)
(*   Qed. *)

(* End fold_right. *)

(* Section fold_assoc_and_commut. *)
  
(*   Variable A B :Type. *)
(*   Variable f : A -> A -> A. *)
(*   (* Variable f_associative : associative f. *) *)

(*   Lemma fold_assoc_prop `{Associative A eq f}:  *)
(*     forall l a b, fold_left f l (f a b) = f a (fold_left f l b) . *)
(*     Proof. *)
(*       induction l;  intro. *)
(*       intros b. simpl. reflexivity. *)
(*       intro b. simpl.  rewrite <- IHl. rewrite (associative a0 b a). *)
(*       reflexivity. *)
(*    Qed. *)


(*   Lemma fold_right_assoc_prop `{Associative A eq f}:  *)
(*     forall l a b, fold_right f (f a b) l = f (fold_right f a l) b . *)
(*     Proof. *)
(*       induction l;  intro. *)
(*       intros b. simpl. reflexivity. *)
(*       intro b. simpl.  rewrite IHl. rewrite (associative ). *)
(*       reflexivity. *)
(*    Qed. *)

(*    Lemma fold_assoc_generalized_prop `{Associative A eq f} (f' : B-> A) :  *)
(*      forall l a b, fold_left (fun acc elem => f acc (f' elem))  l (f a b) = f a (fold_left (fun acc elem => f acc (f' elem)) l b) . *)
(*    Proof. *)
(*      induction l; intro. *)
(*      intros b. simpl. reflexivity. *)
(*      intro b. simpl.  rewrite <- IHl. rewrite (associative a0 b (f' a)). *)
(*      reflexivity. *)
(*    Qed. *)

(*    Lemma fold_right_assoc `{Associative A eq f} (f' : B-> A) :  *)
(*      forall l a b, fold_right (fun elem acc => f (f' elem)  acc)  (f a b) l  = f  (fold_right (fun elem acc => f  (f' elem) acc) a l) b . *)
(*    Proof. *)
(*      induction l; intro. *)
(*      intros b. simpl. reflexivity. *)
(*      intro b. simpl.  rewrite  IHl. rewrite (associative). *)
(*      reflexivity. *)
(*    Qed. *)
    
(*    Generalizable Variables e. *)
(*    Lemma fold_left_assoc_with_id_prop `{Associative A eq f} `{NeutralRight A eq f e} : *)
(*     forall l a, fold_left f l a = f a (fold_left f l e) . *)
(*     Proof. *)
(*       intros. *)
(*       rewrite <- (right_neutral a). *)
(*       rewrite fold_assoc_prop. rewrite right_neutral. *)
(*       reflexivity. *)
(*     Qed. *)

(*    Lemma fold_right_assoc_with_id_prop `{Associative A eq f} `{NeutralLeft A eq f e} : *)
(*     forall l a, fold_right f a l = f  (fold_right f e l)  a. *)
(*     Proof. *)
(*       intros. *)
(*       rewrite <- (left_neutral a). *)
(*       rewrite fold_right_assoc_prop. rewrite left_neutral. *)
(*       reflexivity. *)
(*     Qed. *)

(*    Lemma fold_left_assoc_with_id_generalized_prop `{Associative A eq f} `{NeutralRight A eq f e} (f' : B-> A)  : *)
(*      forall l a , fold_left (fun acc elem => f acc (f' elem))  l a = f a (fold_left (fun acc elem => f acc (f' elem)) l e) . *)
(*     Proof. *)
(*       intros. *)
(*       rewrite <- (right_neutral a). *)
(*       rewrite fold_assoc_generalized_prop. rewrite right_neutral. *)
(*       reflexivity. *)
(*     Qed. *)


(*    Lemma fold_right_assoc_with_id_generalized `{Associative A eq f} `{NeutralLeft A eq f e} (f' : B-> A)  : *)
(*      forall l a , fold_right (fun elem acc => f  (f' elem) acc)  a l = f (fold_right (fun elem acc => f (f' elem) acc ) e l)  a. *)
(*     Proof. *)
(*       intros. *)
(*       rewrite <- (left_neutral a). *)
(*       rewrite fold_right_assoc. rewrite left_neutral. *)
(*       reflexivity. *)
(*     Qed. *)


(*   (* Variable f_commutative : commutative f. *)   *)
(*   Lemma fold_assoc_and_commut_prop1  `{Associative A eq f}  `{Commutative A eq f}: *)
(*     forall l a b, fold_left f l (f a b) = f (fold_left f l a) b. *)
(*   Proof. *)
(*     induction l. *)
(*     reflexivity. *)
(*     intros. *)
(*     simpl. *)
(*     rewrite <- IHl. *)
(*     rewrite (associative a0 b). *)
(*     rewrite  (associative a0 a). *)
(*     rewrite (commutative a b). *)
(*     reflexivity. *)
(*   Qed. *)

(*   Lemma fold_assoc_and_commut_prop2   `{assoc: Associative A eq f}  `{commut : Commutative A eq f}:  *)
(*     forall l a, fold_left f l a = fold_right f a l. *)
(*     Proof. *)
(*       induction l; intro. *)
(*       reflexivity. *)
(*       simpl. *)
(*       rewrite (commutative a (fold_right f a0 l)). *)
(*       rewrite <- IHl. auto using (fold_assoc_and_commut_prop1 ) . *)
(*    Qed. *)


(* End fold_assoc_and_commut. *)

(* Section forallb. *)

(*   Lemma forallb_is_fold_right_andb : forall (A:Type) (f:A->bool) l, *)
(*     forallb f l = fold_right andb true (map f l). *)
(*   Proof. *)
(*     induction l. *)
(*     reflexivity. *)
(*     simpl. *)
(*     rewrite IHl. *)
(*     reflexivity. *)
(*   Qed. *)
(* End forallb. *)

(* Section fold_bool. *)
  
(*   Variable A : Type. *)
(*   Variable f : A->bool. *)

(*   (* FD  *)
(*      -Replace- *)
(*      -fold_left_false- *)
(*      Lemma foldleft_false: forall  (la: list A), *)
(*      fold_left (fun b a=>b && f a) la false = false.  *)
    
(*      -fold_left_true- *)
(*      fold_left_true replaces *)
(*      Lemma foldleft_true: forall  (la: list A), *)
(*      fold_left (fun b a=>b && f a) la true = forallb f la. *)
     
(*      (1) fun a b=>a && f b == fun a b => andb a (f b) *)
(*      (2) fold_left (fun a b => f a (g b)) l x = fold_left f (map g l) x   *)

(*      -Use- *)
(*      fold_left_map_compose_right *)

(*      -Add- *)
     
(*      *) *)

(*   Instance andb_associ : Associative andb. *)
(*   Proof. *)
(*     constructor; auto using  andb_assoc. *)
(*   Qed. *)

(*   Instance andb_commut : Commutative andb. *)
(*   Proof. *)
(*     constructor; auto using  andb_comm. *)
(*   Qed. *)
  
(*   Lemma fold_left_false :  *)
(*     forall l, fold_left andb l false = false. *)
(*   Proof. *)
(*     induction l; auto. *)
(*   Qed. *)

(*   Lemma fold_right_false : forall l, *)
(*     fold_right andb false l = false. *)
(*   Proof. *)
(*     intros. *)
(*     rewrite <- (fold_assoc_and_commut_prop2 (f:=andb)); *)
(*       auto using fold_left_false, andb_assoc, andb_comm. *)
(*   Qed. *)
  
(*   Lemma forallb_is_fold_left_true : forall (l:list A), *)
(*     forallb f l = fold_left andb (map f l) true. *)
(*   Proof. *)
(*     intros. *)
(*     rewrite  (fold_assoc_and_commut_prop2 (f:=andb)); *)
(*       auto using forallb_is_fold_right_andb, andb_assoc, andb_comm. *)
(*   Qed. *)

(*   Lemma forallbApp :  *)
(*     forall (l1 l2:list A) ,  *)
(*       forallb f (l1++l2) = forallb f l1 && forallb f l2. *)
(*   Proof. *)
(*     intros l1 l2. *)
(*     induction l1. *)
(*     reflexivity. *)
(*     simpl. rewrite IHl1. intuition.  *)
(*   Qed. *)

(* End fold_bool. *)

(* Section fold_app. *)

(* (* *)
(* The accumulator of fold_left can be concatened in front of the list for app *)
(* *) *)
(* Lemma fold_left_app_acc : forall (A : Type) l l1, *)
(*   fold_left (fun (x y : list A) => x ++ y) l l1 = l1 ++ fold_left (fun (x y : list A) => x ++ y) l nil. *)
(* Proof. *)
(* induction l ; intros ; simpl. *)
(*  rewrite app_nil_r. reflexivity. *)
(*  rewrite IHl. rewrite (IHl a). intuition.  *)
(* Qed. *)


(* Lemma fold_left_app_general : forall (A : Type) l l' l1, *)
(*   fold_left (fun (x y : list A) => x ++ y) (l++l') l1 = l1 ++ fold_left (fun (x y : list A) => x ++ y) l  nil ++ fold_left (fun (x y : list A) => x ++ y) l'  nil. *)
(* Proof. *)
(*   intros A l l' l1. *)
(*   rewrite fold_left_app_acc.  revert l1. *)
(* induction l ; intros ; simpl. *)
(*   reflexivity. *)
(*   rewrite fold_left_app_acc.   *)
(*   replace (fold_left (fun x y : list A => x ++ y) l a ) with (a++fold_left (fun x y : list A => x ++ y) l nil ).  *)
(*      Focus 2. symmetry;   rewrite fold_left_app_acc.  reflexivity. *)
(*  rewrite IHl. *)
(*  repeat rewrite app_assoc. *)
(*  reflexivity. *)
(* Qed. *)


(* Lemma fold_left_app_nil : forall(A : Type)  (ll: list (list A)), *)
(*   fold_left ( fun x y => app x y) ll nil = nil *)
(*   -> *)
(*   forall l, In l ll -> l=nil *)
(* . *)
(* Proof.   *)
(*   intros A ll H l H0. *)
(*   elim (in_split l ll H0). *)
(*   intros ll' H1. elim H1; clear H1; intros ll'' H'. *)
(*   rewrite H' in H. *)
(*   rewrite fold_left_app_general in H. *)
(*   simpl in H. *)
(*   generalize (app_eq_nil _ _ H). *)
(*   intros H1. *)
(*   destruct H1 as [ ll'_nil l_ll'_nil]. *)
(*   rewrite fold_left_app_acc in l_ll'_nil. *)
(*   destruct (app_eq_nil _ _ l_ll'_nil) as [l_nil ll''nil]. *)
(*   auto. *)
(* Qed. *)

(* Implicit Arguments fold_left_app_nil [A]. *)

(* Lemma fold_left_all_nil : forall(A : Type)  (ll: list (list A)), *)
(*   (forall l, In l ll -> l=nil) *)
(*   -> *)
(*   fold_left ( fun x y => app x y) ll nil = nil *)
(* . *)
(* Proof.   *)
(*   intros A ll H. *)
(*   induction ll. *)
(*       reflexivity.   *)
      
(*       simpl. *)
(*       rewrite fold_left_app_acc.  *)
(*       rewrite (H a).       *)
(*       rewrite IHll.  *)
(*       reflexivity.  *)
(*       intros l H0. apply H. *)
(*       simpl. right; apply H0. *)
(*       simpl. *)
(*       left; reflexivity. *)
(* Qed. *)

(* Implicit Arguments fold_left_all_nil [A]. *)

(* Lemma fold_left_app_first_elem : forall(A : Type)  (ll: list (list A)) (a:A) (l:list A), *)
(*   fold_left (fun x y => app x y) ll nil = a::l *)
(*   -> *)
(*   exists l', exists lnil,exists lrest, ll=lnil++(cons (a::l') nil)++lrest /\ forall l', In l' lnil -> l'=nil. *)
(* Proof.   *)
(*   intros A ll a l H. *)
(*     induction ll. *)
(*             simpl in H; discriminate. *)
            
(*             destruct a0 as [|a' l']. *)
(*             (* case a0 is nil *) *)
(*                     simpl in H.  *)
(*                     elim  (IHll H).  *)
(*                     intros l' H0. *)
(*                     elim H0. clear H0. intros ll' H1. elim H1; clear H1. *)
(*                     intros ll'' H0. *)
(*                     destruct  H0 as [ ll_ll' ll'_nil]. *)
                    
(*                     exists l'; exists (nil::ll'); exists (ll''). *)
(*                     rewrite ll_ll'. *)
(*                     split;[reflexivity|]. *)
(*                     intros l'0 H0. simpl in H0. elim H0; auto. *)
                    
(*                     simpl in H. rewrite fold_left_app_acc in H. *)
(*                     simpl. *)
(*             (* case a0 is (a'::l')::ll *) *)
(*                     assert (aa' :a=a')by (injection H; auto). *)
(*                     assert (l_l'_fold :l=l' ++fold_left (fun x y : list A => x ++ y) ll nil) by (injection H;auto). *)
(*                     exists l'. *)
(*                     rewrite aa'. *)
(*                     exists nil. *)
(*                     exists ll. *)
(*                     split;[reflexivity| intros l'0 faux; contradict faux]. *)
(* Qed. *)
(* Implicit Arguments fold_left_app_first_elem [A]. *)

(* Lemma fold_left_app_last_elem : forall(A : Type)  (ll: list (list A)) (a:A) (l:list A) , *)
(*   fold_left (fun x y => app x y) ll [] = l++[a] *)
(*   -> *)
(*   exists l', exists lnil,exists lrest, ll= lrest++(cons (l'++ cons a nil) nil)++lnil /\ forall l', In l' lnil -> l'=nil. *)
(* Proof.   *)
(*   intros A0 ll a l H. *)
(*   induction ll using rev_ind.  *)
(*   (* case ll = [] *) *)
(*   simpl in H.  contradict H. apply app_cons_not_nil. *)

(*   (* case ll = ll++[x] *) *)
(*   rewrite fold_left_app in H.  *)
(*   induction x using rev_ind.  *)
(*   simpl in H. rewrite app_nil_r in H. *)
  
(*   elim  (IHll H).  *)
(*   intros l' H0. *)
(*   elim H0. clear H0. intros ll' H1. elim H1; clear H1. *)
(*   intros ll'' H0. *)
(*   destruct  H0 as [ ll_ll' ll'_nil]. *)
  
(*   exists l'; exists (ll'++[[]]); exists (ll''). *)
(*   split;[firstorder|]. *)
(*   auto. (*  change ((l' ++ [a]) :: ll') with ([(l' ++ [a]) ]++ ll');  *) *)
(*   rewrite  ll_ll'. repeat rewrite app_assoc. reflexivity. *)
(*   intros l'0 H0. elim (in_app_or _ _  l'0 H0) .  intro; apply (ll'_nil);auto. firstorder.  *)
(*   rewrite (fold_left_app_acc ) in H.  simpl.         *)
(*   replace (fold_left (fun x y : list A0 => x ++ y) [x0 ++ [x]] []  ) with ( x0 ++ [x]  ) in H by firstorder. *)
(*   simpl in IHx. *)
(*   assert (x=a). *)
(*   rewrite  app_assoc in H. *)
(*   elim  (app_inj_tail _ _ _ _ H ). *)
(*   auto. *)
(*   rewrite H0. *)
(*   exists x0; exists (@nil (list A0)); exists ll. firstorder. *)
(* Qed. *)

(* Implicit Arguments fold_left_app_last_elem [A]. *)
(* Implicit Arguments fold_left_app_first_elem [A]. *)
(* End fold_app. *)

(* Section fold_sum. *)

(* (* *)
(* It is equivalent to sum from the beginning or from the end of the list (generalisable a tout operateur binaire...) *)
(* *) *)
(* Lemma folf_left_sum : forall l x n,  *)
(*   fold_left (fun a0 b0 : nat => a0 + b0) (l ++ x :: nil) n = fold_left (fun a0 b0 : nat => a0 + b0) l (n + x). *)
(* Proof. *)
(* induction l ; intros ; simpl. *)
(*  reflexivity. *)
(*  rewrite IHl. replace (n + a + x) with (n + x + a) by ring. reflexivity. *)
(* Qed. *)

(* (*  *)
(* We can get the acc out of fold_left *)
(* *) *)
(* Lemma fold_left_simpl : forall l x,  *)
(*   fold_left (fun x y : nat => x + y) l x = (fold_left (fun x y : nat => x + y) l 0) + x. *)
(* Proof. *)
(* induction l ; simpl ; intros.  *)
(*  reflexivity. *)
(*  rewrite IHl. symmetry. rewrite IHl. ring. *)
(* Qed. *)


(* End fold_sum. *)
(* Section  Length. *)


(* Lemma fold_left_app_length : forall (A : Type) l l', *)
(*   length (fold_left (fun (x y : list A) => x ++ y)  l l') = fold_left (fun (x y : nat) => x + y) (map (@length A) l)  (length l'). *)
(* Proof. *)
(*   intros A l l'. *)
(*   induction l. *)
(*        reflexivity. *)
       
(*        simpl. *)
(*        rewrite fold_left_app_acc.   *)
(*        autorewrite with length. *)
(*        rewrite fold_left_app_acc in IHl.   *)
(*        autorewrite with length in IHl. *)
(*        rewrite (plus_comm (length l')). rewrite <- plus_assoc. rewrite IHl. *)
(*        rewrite fold_left_simpl. *)
(*        rewrite (fold_left_simpl _  (length a +length l')). *)
(*        intuition.  *)
(* Qed. *)
(* End Length. *)
(* Hint Rewrite fold_left_app_length : length. *)



(* Definition forAll (A:Type) (P:A->Prop) (l:list A) :=  *)
(*   List.fold_right (fun e prop=>P e/\prop) True l.   *)

(* Lemma forAllEquivForAllIn: *)
(*   forall(A:Type)(P:A->Prop)(l:list A), *)
(*     forAll P l <->forall e, In e l -> P e. *)
(* Proof. *)
(*   intros A P l. *)
(*   induction l; split; *)
(*   [   *)
(*     intros Hnil e Hin ; contradict Hin | *)
(*     simpl; auto | *)
(*     simpl; intros H e He;  destruct He; destruct H as [Ha Hin]; *)
(*       [ rewrite <-H0 | apply IHl ]; auto | *)
(*         simpl ; intros H; rewrite IHl; split;  *)
(*     [ apply H; left ; auto | *)
(*       intros e Hin; apply H; right; auto] ]. *)
(* Qed. *)

(* Lemma forAllApp:  *)
(*   forall(A:Type)(P:A->Prop)(l1 l2:list A), *)
(*     forAll P l1 /\ *)
(*     forAll P l2 <-> *)
(*     forAll P (l1++l2). *)
(* Proof. *)
(*   intros A P l1 l2; *)
(*   split;  *)
(*     intros H; unfold forAll. *)
(*     rewrite fold_right_app. *)
(*     induction l1; simpl in*. *)
(*       destruct H; assumption. *)
(*       split; destruct H; destruct H; try(apply IHl1; split); assumption. *)
(*     unfold forAll in H. *)
(*     induction l1; simpl in*. *)
(*       split; trivial. *)
(*       apply and_assoc; split; destruct H. *)
(*         assumption. *)
(*         apply IHl1. assumption. *)
(* Qed. *)

